<?php

App::uses('EvCheckoutAppController', 'EvCheckout.Controller');

class OrdersController extends EvCheckoutAppController {

	public function beforeFilter() {
		parent::beforeFilter();

		$this->Auth->allow(array('complete', 'cancel'));
	}

	public function complete() {
		if (CakePlugin::loaded('EvTransactions') && ! empty($this->request->query['transaction'])) {
			$this->TransactionsManager = $this->loadComponent('EvTransactions.Transactions');
			$this->OrderManager = $this->loadComponent('EvCheckout.OrderManager');

			if ($this->TransactionsManager->checkPayment()) {
				$orderId = $this->OrderManager->buildOrder($this->request->query['transaction']);

				// process basket
				// call hooks
				// add email to queue

				die('OUTPUT SUCCESS TEMPLATE');
			} else {

				die('OUTPUT FAILED TEMPLATE');
			}
		}

		die('OUTPUT COMPLETE TEMPLATE');
	}

	public function cancel() {
		if (CakePlugin::loaded('EvTransactions') && ! empty($this->request->query['transaction'])) {
			$this->TransactionsManager = $this->loadComponent('EvTransactions.Transactions');

			$this->TransactionsManager->failTransaction(
				$this->request->query['transaction'],
				'The order was cancelled by the user'
			);
		}

		die('OUTPUT CANCEL TEMPLATE');
	}

}
